#ifdef WINVER
#undef WINVER
#endif
#define WINVER 0x0501
#include <Ws2tcpip.h>
#include <stdio.h>

int inet_pton(int af, const char *src, void *dst) {
  struct sockaddr_storage ss;
  int sslen = sizeof(ss);

	switch (af) {
	case AF_INET:
	case AF_INET6:
    break;
  default:
    errno = WSAEAFNOSUPPORT;
    return SOCKET_ERROR;
	}

  if (SOCKET_ERROR != WSAStringToAddressA((char*)src, af, NULL, (struct sockaddr*)&ss, &sslen)) {
    if (af == AF_INET) {
      memcpy(dst, &((struct sockaddr_in *)&ss)->sin_addr, sizeof(((struct sockaddr_in *)&ss)->sin_addr));
    } else {
      memcpy(dst, &((struct sockaddr_in6 *)&ss)->sin6_addr, sizeof(((struct sockaddr_in6 *)&ss)->sin6_addr));
    }
    return 1;
  } else {
    return SOCKET_ERROR;
  }
}
